/* ----- BATTLE MOSQUITO -----      */
/*         - Programmed by stada -  */

#include <sys/bios.h>
#include <stdio.h>
#include <stdlib.h>
#include "def.h"

/* O[oϐ */
int m_key;
int m_keyhit;
int m_status;	/* Q[̏ */
unsigned int m_sc;	/* _ */
unsigned int m_hi_sc;	/* ō_ */
unsigned int m_hit;	/* qbg */
unsigned int m_hi_hit;	/* ōqbg */
unsigned int m_endTim;	/* c莞 */

char str[256];	/* \p */

void getKey(void)
{
    static int keyold = 0;

	m_key		= key_press_check();
    m_keyhit	= m_key & (~keyold);
    keyold		= m_key;
}

/* LN^ */
/*  */
typedef struct{
    unsigned int x;
	unsigned int y;
    int vx;
	int vy;
	int tim;
}Ka;
static Ka m_ka;

/*  */
typedef struct{
    unsigned int x;
	unsigned int y;
    int h;
	int w;
}Te;
static Te m_te;

/* LN^ݒ */
void init_chr(Ka *k, Te *t)
{
	rand();	/* dummy */
	k->x = rand() * 2;
	k->y = rand() * 2;
	k->vx = ((rand() * 2) - RAND_MAX) / SCALE;
	k->vy = ((rand() * 2) - RAND_MAX) / SCALE;
	k->tim = rand() / 32;	/* max 1024 */

	t->x = rand() * 2;
	t->y = rand() * 2;
	t->h = 16;
	t->w = 16;
}

/* ̉̏oʒu */
void ka_next(Ka *k)
{
	k->x = rand() * 2;
	k->y = rand() * 2;
}

/* ̕ */
void ka_dir(Ka *k)
{
	k->vx = ((rand() * 2) - RAND_MAX) / SCALE;
	k->vy = ((rand() * 2) - RAND_MAX) / SCALE;
	k->tim = rand() / 32;	/* max 1024 */
}

/* ړ */
void ka_move(Ka *k)
{
	k->x = (k->x + k->vx) % 65536;
	k->y = (k->y + k->vy) % 65536;
}
/* ړ */
void te_move(Te *t)
{
	if(m_key & KEY_X1){
		t->y = (t->y + Y_INC) % 65536;
	}
	else if (m_key & KEY_X2){
		t->x = (t->x + X_INC) % 65536;
	}
	else if (m_key & KEY_X3){
		t->y = (t->y - Y_INC) % 65536;
	}
	else if (m_key & KEY_X4){
		t->x = (t->x - X_INC) % 65536;
	}
}

/* ʐݒ */
void set_vol(int dx, int dy)
{
	int vl;	/**/
	int vr; /*E*/

	if (dx > 127)
		dx = dx - 255;
	if (dy > 127)
		dy = dy - 255;		

	if (dx < -90){
		vl = 0;
		vr = 0;
	}else if (dx < 0){
		vl = 15;
		vr = 15 + (dx / 6);
	}else if (dx < 91){
		vl = 15 - (dx / 6);
		vr = 15;
	}else{
		vl = 0;
		vr = 0;
	}

	if (dy < -90){
		vl = 0;
		vr = 0;
	}else if (dy < 0){
		vl = vl + (dy / 6);
		vr = vr + (dy / 6);
	}else if (dy < 91){
		vl = vl - (dy / 6);
		vr = vr - (dy / 6);		
	}else{
		vl = 0;
		vr = 0;
	}

	if (vl < 0)
		vl = 0;
	if (vr < 0)
		vr = 0;

	sound_set_volume(CH1, (vl << 4 | vr));

#if 1
	text_put_string(8, 10, "MOSQUITO POS");
	sprintf(str, "x: %d  ", dx);
	text_put_string(10, 11, str);
	sprintf(str, "y: %d  ", dy);
	text_put_string(10, 12, str);	
#endif
}

/*  */
int clap(int cv, int x, int y, Ka *k, Te *t)
{
	if(cv == 0){
		if(m_keyhit & KEY_A){	
			cv = 15;
			/* 蔻 */
			if(x < t->w && y < t->h){
				m_hit++;
				m_sc+=(REST_TIME - (m_endTim - (unsigned)sys_get_tick_count()) / CNT2SEC);
				ka_next(k);
				ka_dir(k);
			}
		}
	}else{
		cv-=8;
		if(cv < 0){
			cv = 0;
		}
	}
	return cv;
}


/* ʕ\ */
void showInfo(Ka *k, Te *t)
{
	sprintf(str, "   SCORE %u  ", m_sc);
	text_put_string(1, 4, str);
	sprintf(str, "    HIT %u  ", m_hit);
	text_put_string(15, 4, str);

	sprintf(str, "TIME=%u  ", (m_endTim - (unsigned)sys_get_tick_count()) / CNT2SEC);
	text_put_string(10, 7, str);
}

/* ^Cg */
void showTitle(void)
{
	text_screen_init();

	sprintf(str, "HI SCORE %u  ", m_hi_sc);
	text_put_string(1, 2, str);
	sprintf(str, "TOP HIT %u  ", m_hi_hit);
	text_put_string(15, 2, str);

	text_put_string(6, 7, "BATTLE MOSQUITO");
	text_put_string(6, 9, "PRESS B TO START");
}

/* C */
int main(void)
{
	unsigned int tick;
	unsigned int nextDirTim;	/* Ⴊ]܂ł̎ */
	int clapVol;	/* ̉ */
	int dx;			/* Ǝ̋ */
	int dy;

	/* g`f[^ */
	static unsigned char wv[] = {
		0xb8, 0xcf, 0x27, 0x50, 0xc9, 0xbf, 0x16, 0x94,
		0xbf, 0x26, 0xe9, 0x4a, 0x50, 0xea, 0x59, 0x30
	};

	Ka *ka;
	Te *te;

	ka = &m_ka;
	te = &m_te;


	/* ݒ */
	m_sc = 0;
	m_hi_sc = 0;
	clapVol = 0;
	dx = 0;
	dy = 0;
	m_status = ST_TITLE;
	text_screen_init();		/* ʃNA */
	srand(((unsigned)sys_get_tick_count() % 256));
	
	/* ^Cg */
	showTitle();
	init_chr(ka, te);	

	/*  */
	sound_init();
	sound_set_channel(CH1_ON | CH4_ON | NOISE_MODE);
	sound_set_output(HEADPHONE_ON);
	sound_set_wave(CH1, wv);
	sound_set_volume(CH1, 0x00);
	sound_set_volume(CH4, 0x00);
	/* gf: 3.072 * 10^6 / ((2048 - n) * 32) Hz */
	sound_set_pitch(CH1, 1790);
	sound_set_noise(NOISE_5 | NOISE_COUNTER_RESET | NOISE_COUNTER_ON);

	/* C[v */
	for(;;){
		getKey();
		/* ^Cg */
		if(m_status == ST_TITLE){
	        if(m_keyhit & KEY_B){
				text_screen_init();

				sprintf(str, "HI SCORE %u  ", m_hi_sc);
				text_put_string(1, 2, str);
				sprintf(str, "TOP HIT %u  ", m_hi_hit);
				text_put_string(15, 2, str);

				/* ϐ */
				m_hit = 0;
				m_sc = 0;
				ka_next(ka);
				ka_dir(ka);
				nextDirTim = (unsigned)sys_get_tick_count() + ka->tim;
				m_endTim = (unsigned)sys_get_tick_count() + REST_TIME * CNT2SEC;
				m_status = ST_GAME;
			}
		}

		else if(m_status == ST_GAME){
		/* Q[ */
			tick = (unsigned)sys_get_tick_count();	
	
			ka_move(ka);	/* ړ */
			te_move(te);	/* ړ */
			
			/* Ǝ̋ */
			dx = (ka->x - te->x) / SCALE;
			dy = (ka->y - te->y) / SCALE;

			showInfo(ka, te);	/* ʕ\ */
	
			set_vol(dx, dy);	/* ʐݒ */ 
	
			clapVol = clap(clapVol, dx, dy, ka, te);	/*  */
			sound_set_volume(CH4, clapVol << 4 | clapVol);
	
			/* ύX */
			if((unsigned)sys_get_tick_count() > nextDirTim){
				ka_dir(ka);
				nextDirTim = (unsigned)sys_get_tick_count() + ka->tim;
			}
			/* Q[I */
			if((unsigned)sys_get_tick_count() > m_endTim){

				text_screen_init();

				/* nCXRAXV */
				if (m_sc > m_hi_sc){
					m_hi_sc = m_sc;
					text_put_string(10, 12, "HI SCORE!!");
				}
				if (m_hit > m_hi_hit){
					m_hi_hit = m_hit;
					text_put_string(10, 14, "TOP HIT!!");
				}
				
				/* ʕ\ */
				sprintf(str, "HI SCORE %u  ", m_hi_sc);
				text_put_string(1, 2, str);
				sprintf(str, "TOP HIT %u  ", m_hi_hit);
				text_put_string(15, 2, str);
				sprintf(str, "   SCORE %u  ", m_sc);
				text_put_string(1, 4, str);
				sprintf(str, "    HIT %u  ", m_hit);
				text_put_string(15, 4, str);

				sprintf(str, "    STOP!  ");
				text_put_string(8, 8, str);
				sprintf(str, "PRESS B TO RETURN");
				text_put_string(8, 10, str);

				sound_set_volume(CH1, 0);
				sound_set_volume(CH4, 0);
				m_status = ST_END;
			}
			while((unsigned)sys_get_tick_count() - tick < 1 ){
			}											/* ^C}EFCg */
	        if(m_keyhit & KEY_START){
			    break;			/* STARTEXIT */
			}
		}

		else if(m_status == ST_END){
		/* Q[I[o[ */
    	    if(m_keyhit & KEY_B){
				showTitle();
			    m_status = ST_TITLE;
			}	
		}
	    if(m_keyhit & KEY_START){
		    break;			/* STARTEXIT */
		}
	}
}