/*
 * $Id: putipati.c,v 1.1.1.1 2002/05/04 09:19:09 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */

/**
 * Putipati main.
 *
 * @version $Revision: 1.1.1.1 $
 */
#include <sys/bios.h>
#include <stdlib.h>
#include <resource.h>

#include "putipati.h"
#include "gamemng.h"
#include "dispmng.h"
#include "soundmng.h"
#include "attrcmng.h"

Boolean loopf = TRUE;
int timer;

extern void far *_resource;

static void loadResources() {
  BYTE far *rsc = (BYTE far *)_resource;
  int  bgmCnt = 0;
  while(((res_t far *)rsc)->magic == RESID) { 
    switch ( ((res_t far *)rsc)->type ){
    case RESID_MUSIC:
      bgmBuf[bgmCnt] = (res_music_t far *)rsc;
      bgmCnt++;
      break;
    case RESID_SE:
      seBuf = (res_se_t far *)rsc;
      break;
    }
    rsc += (((res_t far *)rsc)->size << 4);
  }
}

void startApplication() {
  loadResources();
  initDisplay();
  initSound();
  randomize();
  if ( !loadPrefs() ) {
    initRanking();
  }
  gotoTitle();
}

void stopApplication() {
  closeSound();
  closeDisplay();
}

/* loop interval */
#define INTERVAL 2

/**
 * Proceed one frame.
 * gameStatus.status represents a state of game.
 */
void loop() {
  unsigned long startTick = sys_get_tick_count();
  unsigned loopTick;

  switch ( gameStatus.status ) {
  case GAME_IN_PROGRESS:
    handleInGame();
    break;
  case TITLE:
    handleTitle();
    break;
  case GAMEOVER:
    handleGameover();
    break;
  case PAUSE:
    handlePause();
    break;
  }
  loopTick = sys_get_tick_count()-startTick;
  if ( loopTick < INTERVAL ) {
    sys_wait(INTERVAL-loopTick);
  }
  timer++;
}

void main(int argc, char *argv[]) {
  startApplication();
  while ( loopf ) {
    loop();
  }
  stopApplication();
  bios_exit();
}
