/*
 * $Id: soundmng.c,v 1.2 2002/05/04 11:29:08 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */

/**
 * Sound manager.
 *
 * @version $Revision: 1.2 $
 */
#include <stdio.h>
#include "il_sound.h"

#include "putipati.h"
#include "soundmng.h"

static SoundIL soundIL;
static Boolean soundOn;
void far *bgmBuf[BGM_NUM];
void far *seBuf;

/**
 * Initialize SoundIL.
 */
void initSound() {
  if( open_sound_il(&soundIL) != E_FS_SUCCESS ){
    soundOn = FALSE;
    return;
  }
  soundOn = TRUE;
  sounddrv_init();
  sound_open();
  se_play(seBuf, -1);
}

/**
 * Close SoundIL.
 */
void closeSound() {
  if ( !soundOn ) return;
  sound_close();
  sounddrv_release();
}

void playBgm(int num, int mode) {
  if ( !soundOn ) return;
  if ( bgm_check() ) bgm_stop();
  bgm_play(bgmBuf[num], mode);
}

void stopBgm() {
  if ( !soundOn ) return;
  bgm_stop();
}

void fadeBgm() {
  if ( !soundOn ) return;
  bgm_fadeout();
}

void playSe(int num) {
  if ( !soundOn ) return;
  se_play_n(num);
}
